!
subroutine LA17(A, D, T, B, Eps, Max, X, Error)
!     Ax=b  
!  A,     LA15
!declaration
real, intent(in):: A(:,:), D(:), B(:), Eps
integer, intent(in):: T(:)
integer, intent(inout):: Max
real:: X(:)
integer:: Error
real, parameter:: kof=0.5
real, allocatable:: R(:)
real SX, SR, SRp, XX, Sum
integer i, j, p, m, N
!begin
  N=size(A,1)
  allocate(R(N))
  X=B; p=0
!  
  do i=1, N
    m=T(i);  Sum=X(m); X(m)=X(i)
    do j=1, i-1
      Sum=Sum-A(j,i)*X(j)
    end do
    X(i)=Sum    ! X(i)=Sum/D(i)
  end do
  do i=1,N;  X(i)=X(i)/D(i); end do
  do i=N, 1, -1
    Sum=X(i)
    do j=i+1, N
      Sum=Sum-A(i,j)*X(j)
    end do
      X(i)=Sum
  end do
  do i=1, N-1
    m=T(i)
    if (m/=i) then
      XX=X(m); X(m)=X(i); X(i)=XX
    end if
  end do
!  
10  continue
! r=b-Ax
    do i=1, N
      Sum=B(i)
      do j=1, i
        Sum=Sum-A(i,j)*X(j)
      end do
	  do j=i+1, N
	    Sum=Sum-A(j,i)*X(j)
	  end do
      R(i)=Sum
    end do
!  
    do i=1, N
      m=T(i);  Sum=R(m); R(m)=R(i)
      do j=1, i-1
        Sum=Sum-A(j,i)*R(j)
      end do
      R(i)=Sum    ! R(i)=Sum/D(i)
    end do
    do i=1,N;  R(i)=R(i)/D(i); end do
    do i=N, 1, -1
      Sum=R(i)
      do j=i+1, N
        Sum=Sum-A(i,j)*R(j)
      end do
      R(i)=Sum
    end do
    do i=1, N-1
      m=T(i)
      if (m/=i) then
        XX=R(m); R(m)=R(i); R(i)=XX
      end if
    end do
! 
    do i=1, N
      if (abs(R(i))>Eps*abs(X(i))) goto 15
    end do
    deallocate(R)
    Max=p; Error=0; return
15  continue
    SR=0.0; SX=0.0
    do i=1, N
      SR=SR+abs(R(i)); SX=SX+abs(X(i))
    end do
    if (SR<Eps*SX) then
      deallocate(R)
      Max=p; Error=1; return
    end if
    if (p>0) then
      if (SR>kof*SRp) then
        deallocate(R)
        Max=p; Error=2
        if (p<=1) Error=65
        return
      end if
    end if
    SRp=SR; X=X+R; p=p+1
  if (p<Max) goto 10
  deallocate(R)
  Error=3; return
end subroutine LA17
